\ ############################################################################
\ # propwords.fth - This program defines various Prop-specific words
\ #
\ # Copyright (c) 2012 Dave Hein
\ # MIT Licensed
\ ############################################################################

( PROP WORDS)
hex

( REGISTER ACCESS )
: cnt@ 1f1 cog@ ;
: ina@ 1f2 cog@ ;
: ina! 1f2 cog! ;
: outa@ 1f4 cog@ ;
: outa! 1f4 cog! ;
: dira@ 1f6 cog@ ;
: dira! 1f6 cog! ;
: clkfreq@ 0 @ ;

( BIT SETTING AND CLEARING )
: dirasetbit dira@ or dira! ;
: diraclrbit invert dira@ and dira! ;
: outasetbit outa@ or outa! ;
: outaclrbit invert outa@ and outa! ;

( HUBOPS )
: cogid   ( ... cogid )   0 0cfc0001 cogx1 ;
: locknew ( ... locknum ) 0 0cfc0004 cogx1 ;
: lockret ( locknum ... ) 0cfc0005 cogx1 drop ;
: cogstop ( cognum ... )  0c7c0003 cogx1 drop ;
: coginit ( codeptr dataptr cognum ... cognum )
  >r 0e lshift or 2 lshift r> or 0ffc0002 cogx1 ;

: cognew  ( codeptr dataptr ... cognum ) 8 coginit ;

: waitcnt ( count ... count )
  begin dup cnt@ - 0< until ;

decimal

( ANS UTILITY )
: ms ( msec ... ) clkfreq@ 1000 / * cnt@ + waitcnt drop ;

\ +--------------------------------------------------------------------
\ |  TERMS OF USE: MIT License
\ +--------------------------------------------------------------------
\ Permission is hereby granted, free of charge, to any person obtaining
\ a copy of this software and associated documentation files
\ (the "Software"), to deal in the Software without restriction,
\ including without limitation the rights to use, copy, modify, merge,
\ publish, distribute, sublicense, and/or sell copies of the Software,
\ and to permit persons to whom the Software is furnished to do so,
\ subject to the following conditions:
\ 
\ The above copyright notice and this permission notice shall be
\ included in all copies or substantial portions of the Software.
\ 
\ THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
\ EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
\ MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
\ IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
\ CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
\ TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
\ SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
\ +------------------------------------------------------------------
